"use strict";
var DEFAULT_LIMIT = 50;
var TransitionHistory = (function () {
    function TransitionHistory(state, limit) {
        if (limit === void 0) { limit = DEFAULT_LIMIT; }
        this.stack = [];
        this.index = 0;
        this.limit = limit;
        this.stack.unshift({ state: state });
    }
    TransitionHistory.prototype.getCurrentRecord = function () {
        return this.stack[this.index];
    };
    TransitionHistory.prototype.getPreviousRecord = function () {
        return this.stack[this.index + 1];
    };
    TransitionHistory.prototype.getNextRecord = function () {
        return this.stack[this.index - 1];
    };
    TransitionHistory.prototype.getHistory = function () {
        return {
            index: this.index,
            stack: this.stack,
        };
    };
    TransitionHistory.prototype.rewindHistory = function () {
        this.index = Math.min(this.index + 1, this.stack.length - 1);
    };
    TransitionHistory.prototype.forwardHistory = function () {
        this.index = Math.max(this.index - 1, 0);
    };
    TransitionHistory.prototype.addRecord = function (record) {
        this.stack.splice(0, this.index);
        this.stack.unshift(record);
        if (this.stack.length > this.limit) {
            this.stack.pop();
        }
        this.index = 0;
    };
    return TransitionHistory;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = TransitionHistory;
//# sourceMappingURL=transition-history.js.map