import Key from './key';
import SubscriberPayload from './subscriber-payload';
import TransitionHistory from './transition-history';
import TransitionSet from './transition-set';
export default class Transitioner {
    private history;
    private transitions;
    constructor(transitions: TransitionSet, history: TransitionHistory);
    canTransition(toState: Key, fromState: Key): boolean;
    canUndo(): boolean;
    canRedo(): boolean;
    transition(toState: Key, fromState: Key, data?: any, callback?: (payload: SubscriberPayload) => void): void;
    triggerEvent(event: Key, fromState: Key, data?: any, callback?: (payload: SubscriberPayload) => void): void;
    undoTransition(callback?: (payload: SubscriberPayload) => void): void;
    redoTransition(callback?: (payload: SubscriberPayload) => void): void;
    private findExecutableTransition(toState, fromState);
    private findExecutableTransitionByEvent(event, fromState);
    private getTransitionForUndo();
    private getTransitionForRedo();
}
